## hockeypuck 0.8.1~bzr104

=== Makefile ===

_GOPATH=gopath
GOPATH := $(CURDIR)/$(_GOPATH)

GO=go
HOCKEYPATH=$(GOPATH)/src/launchpad.net/hockeypuck

all:
	GOPATH="${GOPATH}" $(GO) get launchpad.net/hockeypuck/cmd/hockeypuck-mgo
	GOPATH="${GOPATH}" $(GO) install launchpad.net/hockeypuck/cmd/hockeypuck-mgo
	GOPATH="${GOPATH}" $(GO) get launchpad.net/hockeypuck/cmd/hockeypuck-load
	GOPATH="${GOPATH}" $(GO) install launchpad.net/hockeypuck/cmd/hockeypuck-load

fmt:
	gofmt -w=true .

debsrc: debbin clean
	debuild -S

debbin:
	debuild -us -uc -i -b

clean:
	$(RM) -r $(GOPATH)/bin $(GOPATH)/pkg

srcclean:
	$(RM) -r $(GOPATH)

=== debian/changelog ===
hockeypuck (0.8.1~bzr104) raring; urgency=low

  [ Casey Marshall ]
  * mgo/worker.go, mgo/worker_test.go, pgp.go, pgp_types.go,
    pq/worker.go, responses.go:
    - Updates wrt go.crypto branch packet.Read.
    - Fixed an issue where valid public keys preceding an
      invalid public key were not send to the channel.
      LP: #1090980
  * pgp.go, pgp_types.go:
    - Updated unknown/unsupported packet parsing wrt
      changes in go.crypto merge.

 -- Casey Marshall <casey.marshall@gazzang.com>  Tue, 22 Jan 2013 21:10:03 -0600

hockeypuck (0.8~bzr104~raring) raring; urgency=low

  [ Casey Marshall ]
  * Opening 0.8 milestone.
  * cmd/lspgp/main.go, cmd/pktdump/main.go, mgo/worker.go,
    mgo/worker_test.go, pgp.go, pgp_types.go, pq/worker.go,
    responses.go:
    - Switch go.crypto from my fork to proper trunk source.
  * instroot/var/lib/hockeypuck/www/fonts/Droid_Sans =>
    instroot-extra/var/lib/hockeypuck/www/fonts/Droid_Sans
    scripts/crossbuild.sh:
    - Move droid sans font out of debian instroot, used only
      in cross-compile tar build.

  [ Dustin Kirkland ]
  * debian/manpages, debian/install, debian/rules,
    instroot/etc/init/hockeypuck-mgo.conf => debian/upstart,
    removed directory instroot/etc/init:
    - A handful of packaging recommendations

 -- Casey Marshall <casey.marshall@gazzang.com>  Tue, 22 Jan 2013 11:00:00 -0600

hockeypuck (0.7~bzr104~raring) raring; urgency=low

  [ Casey Marshall ]
  * Opening 0.7 milestone.
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, mgo/pks.go, mgo/worker.go,
    pks.go, worker.go:
    - Add support for PKS forwarding. LP: #1075379
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, mgo/worker.go, pks.go,
    worker.go:
    - Consolidate PKS configuration from switches.
    - Consolidate worker process (goroutine) management.
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, mgo/pks.go, mgo/worker.go,
    pks.go, === removed directory cli, server.go, templates.go,
    worker.go:
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, config.go, log.go,
    mgo/client.go, mgo/pks.go, mgo/worker.go, pks.go, === removed
    directory cli, server.go, templates.go, worker.go:
    - Move command line flags to associated components,
      split out config file parsing.
    - Pull up common mgo client connection, reuse in worker & pks sync.
    - Fix net/smtp usage in PKS sync, added backoff delay on SMTP errors.
      LP: #1075379
  * etc/hockeypuck/hockeypuck.conf, mgo/worker.go, pgp_types.go, pks.go:
    - Clean up commented out config example settings.
    - Store cumulative digest of key's packets, only update when changed.
      LP: #1083061
    - Only use *PksTo flag if set. Only log pks poll sleep time if there was a
      retry on SMTP error.
  * mgo/client.go:
    - Simplify ensuring indexes. Added keys.mtime.
  * cmd/hockeypuck-mgo/main.go, debian/postinst, version.go:
    - Add -version flag, setting version file from changelog in postinst.
  * hkp_types.go, mgo/client.go, mgo/pks.go, mgo/worker.go,
    responses.go, server.go, templates.go, worker.go,
    www/templates/layout.tmpl, www/templates/pks/index.tmpl,
    status_types.go, www/templates/pks/status.tmpl:
    - Add op=status page. LP: #1075391
    - Cache last PKS sync status for op=status response.
    - Expose Hostname:Port in Lookup for op=status.
    - MongoDB: Ensure unique index on pksStat.addr.
    - Fixed template context passthru issues.
  * www/templates/header.tmpl:
    - Add link to PKS status page. LP: #1075391
  * mgo/keystats.go:
    - Add map-reduce to calculate hourly and daily totals of
      key creation and modification. LP: #1075391
  * cmd/hockeypuck-mgo/main.go, mgo/client.go, mgo/keystats.go,
    mgo/worker.go, status_types.go, www/templates/pks/status.tmpl:
    - Integrate key stats into op=status page, MR, query fixes.
      LP: #1075391
  * === added directory instroot, etc., scripts/crossbuild.sh:
    - Relocate static system installed files to instroot.
    - Added cross-compilation script. LP: #1086192
  * scripts/crossbuild.sh:
    - Add dist tarball creation.
  * debian/control, debian/install, debian/links:
    - Fix lintian warnings. Linking to fonts-droid for Ubuntu package.
  * instroot/usr/share/man/man1/hockeypuck-load.1:
    - Documented -mail-add=true option.
  * scripts/crossbuild.sh:
    - Add version to dist tarballs.

 -- Casey Marshall <casey.marshall@gazzang.com>  Thu, 13 Dec 2012 21:39:31 -0600

hockeypuck (0.6~bzr104~raring) raring; urgency=low

  [ Casey Marshall ]
  * Opening 0.6 milestone.
  * mgo/worker.go:
    - Fix keyword query iteration. Need to keep allocating new PubKeys,
      was overwriting the same one in the iter loop.
      LP: #1073786
  * cmd/hockeypuck-load/main.go, pgp_types.go, responses.go,
    www/templates/pks/index.tmpl:
    - Display user attribute image subpacket in index templates. LP: #1044773
  * responses.go, www/templates/pks/index.tmpl:
    - Display QR code of public key fingerprint. LP: #1074552
  * www/css/hkp.css, www/templates/header.tmpl:
    - Make logo heading a link.
  * debian/mkdists, debian/rules, Makefile:
    - Remove hockeypuck-pq from binary packages, its not ready for that.
    - Add helper script for slinging multi-distro source packages.
  * cmd/hockeypuck-load/main.go:
    - Add hockeypuck -mail-add option for receiving PKS inbound keys.
      LP: #1075379
  * debian/rules, Makefile:
    - Use the binary targets to get dependencies, use go install
      to build them into local gopath/bin. Simplifies Makefile.
  * mgo/worker.go, pq/worker.go, responses.go, server.go, templates.go,
    worker.go, www/templates/header.tmpl:
    - Create form to add pasted key armor. LP: #1076841
    - /pks/add produces an HTML page confirming added key fingerprints.
    - Clean up ws, cruft.
  * mgo/worker.go, pgp_types.go:
    - Add Ctime & Mtime for status page. LP: #1075391
  * === added directory etc/hockeypuck, cli/cli.go, cmd/hockeypuck-
    mgo/main.go, debian/rules, etc/hockeypuck/hockeypuck.conf,


=== gopath/src/launchpad.net/hockeypuck/debian/changelog ===
hockeypuck (0.8.1) precise; urgency=low

  [ Casey Marshall ]
  * mgo/worker.go, mgo/worker_test.go, pgp.go, pgp_types.go,
    pq/worker.go, responses.go:
    - Updates wrt go.crypto branch packet.Read.
    - Fixed an issue where valid public keys preceding an
      invalid public key were not send to the channel.
      LP: #1090980
  * pgp.go, pgp_types.go:
    - Updated unknown/unsupported packet parsing wrt
      changes in go.crypto merge.

 -- Casey Marshall <casey.marshall@gazzang.com>  Tue, 22 Jan 2013 21:10:03 -0600

hockeypuck (0.8) precise; urgency=low

  [ Casey Marshall ]
  * Opening 0.8 milestone.
  * cmd/lspgp/main.go, cmd/pktdump/main.go, mgo/worker.go,
    mgo/worker_test.go, pgp.go, pgp_types.go, pq/worker.go,
    responses.go:
    - Switch go.crypto from my fork to proper trunk source.
  * instroot/var/lib/hockeypuck/www/fonts/Droid_Sans =>
    instroot-extra/var/lib/hockeypuck/www/fonts/Droid_Sans
    scripts/crossbuild.sh:
    - Move droid sans font out of debian instroot, used only
      in cross-compile tar build.

  [ Dustin Kirkland ]
  * debian/manpages, debian/install, debian/rules,
    instroot/etc/init/hockeypuck-mgo.conf => debian/upstart,
    removed directory instroot/etc/init:
    - A handful of packaging recommendations

 -- Casey Marshall <casey.marshall@gazzang.com>  Tue, 22 Jan 2013 11:00:00 -0600

hockeypuck (0.7) precise; urgency=low

  [ Casey Marshall ]
  * Opening 0.7 milestone.
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, mgo/pks.go, mgo/worker.go,
    pks.go, worker.go:
    - Add support for PKS forwarding. LP: #1075379
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, mgo/worker.go, pks.go,
    worker.go:
    - Consolidate PKS configuration from switches.
    - Consolidate worker process (goroutine) management.
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, mgo/pks.go, mgo/worker.go,
    pks.go, === removed directory cli, server.go, templates.go,
    worker.go:
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, config.go, log.go,
    mgo/client.go, mgo/pks.go, mgo/worker.go, pks.go, === removed
    directory cli, server.go, templates.go, worker.go:
    - Move command line flags to associated components,
      split out config file parsing.
    - Pull up common mgo client connection, reuse in worker & pks sync.
    - Fix net/smtp usage in PKS sync, added backoff delay on SMTP errors.
      LP: #1075379
  * etc/hockeypuck/hockeypuck.conf, mgo/worker.go, pgp_types.go, pks.go:
    - Clean up commented out config example settings.
    - Store cumulative digest of key's packets, only update when changed.
      LP: #1083061
    - Only use *PksTo flag if set. Only log pks poll sleep time if there was a
      retry on SMTP error.
  * mgo/client.go:
    - Simplify ensuring indexes. Added keys.mtime.
  * cmd/hockeypuck-mgo/main.go, debian/postinst, version.go:
    - Add -version flag, setting version file from changelog in postinst.
  * hkp_types.go, mgo/client.go, mgo/pks.go, mgo/worker.go,
    responses.go, server.go, templates.go, worker.go,
    www/templates/layout.tmpl, www/templates/pks/index.tmpl,
    status_types.go, www/templates/pks/status.tmpl:
    - Add op=status page. LP: #1075391
    - Cache last PKS sync status for op=status response.
    - Expose Hostname:Port in Lookup for op=status.
    - MongoDB: Ensure unique index on pksStat.addr.
    - Fixed template context passthru issues.
  * www/templates/header.tmpl:
    - Add link to PKS status page. LP: #1075391
  * mgo/keystats.go:
    - Add map-reduce to calculate hourly and daily totals of
      key creation and modification. LP: #1075391
  * cmd/hockeypuck-mgo/main.go, mgo/client.go, mgo/keystats.go,
    mgo/worker.go, status_types.go, www/templates/pks/status.tmpl:
    - Integrate key stats into op=status page, MR, query fixes.
      LP: #1075391
  * === added directory instroot, etc., scripts/crossbuild.sh:
    - Relocate static system installed files to instroot.
    - Added cross-compilation script. LP: #1086192
  * scripts/crossbuild.sh:
    - Add dist tarball creation.
  * debian/control, debian/install, debian/links:
    - Fix lintian warnings. Linking to fonts-droid for Ubuntu package.
  * instroot/usr/share/man/man1/hockeypuck-load.1:
    - Documented -mail-add=true option.
  * scripts/crossbuild.sh:
    - Add version to dist tarballs.

 -- Casey Marshall <casey.marshall@gazzang.com>  Thu, 13 Dec 2012 21:39:31 -0600

hockeypuck (0.6) precise; urgency=low

  [ Casey Marshall ]
  * Opening 0.6 milestone.
  * mgo/worker.go:
    - Fix keyword query iteration. Need to keep allocating new PubKeys,
      was overwriting the same one in the iter loop.
      LP: #1073786
  * cmd/hockeypuck-load/main.go, pgp_types.go, responses.go,
    www/templates/pks/index.tmpl:
    - Display user attribute image subpacket in index templates. LP: #1044773
  * responses.go, www/templates/pks/index.tmpl:
    - Display QR code of public key fingerprint. LP: #1074552
  * www/css/hkp.css, www/templates/header.tmpl:
    - Make logo heading a link.
  * debian/mkdists, debian/rules, Makefile:
    - Remove hockeypuck-pq from binary packages, its not ready for that.
    - Add helper script for slinging multi-distro source packages.
  * cmd/hockeypuck-load/main.go:
    - Add hockeypuck -mail-add option for receiving PKS inbound keys.
      LP: #1075379
  * debian/rules, Makefile:
    - Use the binary targets to get dependencies, use go install
      to build them into local gopath/bin. Simplifies Makefile.
  * mgo/worker.go, pq/worker.go, responses.go, server.go, templates.go,
    worker.go, www/templates/header.tmpl:
    - Create form to add pasted key armor. LP: #1076841
    - /pks/add produces an HTML page confirming added key fingerprints.
    - Clean up ws, cruft.
  * mgo/worker.go, pgp_types.go:
    - Add Ctime & Mtime for status page. LP: #1075391
  * === added directory etc/hockeypuck, cli/cli.go, cmd/hockeypuck-
    mgo/main.go, debian/rules, etc/hockeypuck/hockeypuck.conf,
    etc/init/hockeypuck-mgo.conf:


=== gopath/src/launchpad.net/hockeypuck/debian/control ===
Source: hockeypuck
Section: net
Priority: optional
Maintainer: Casey Marshall <casey.marshall@gazzang.com>
Build-Depends: debhelper (>= 8.0.0), golang-go
Standards-Version: 3.9.3
Homepage: http://launchpad.net/hockeypuck

Package: hockeypuck
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, fonts-droid
Recommends:
 mongodb-server
Description: OpenPGP Key Server
 Hockeypuck is an OpenPGP Key Server implementing the HTTP Keyserver Protocol.

## hockeypuck 0.9.0147-0ubuntu1

=== debian/changelog ===
hockeypuck (0.9.0147-0ubuntu1) raring; urgency=low

  * Updating Ubuntu to upstream release

 -- Dustin Kirkland <kirkland@ubuntu.com>  Mon, 04 Mar 2013 14:56:24 -0600

hockeypuck (0.9.0147~raring) raring; urgency=low

  [ Casey Marshall ]
  * hkp_types.go, mgo/worker.go, responses.go, server.go,
    status_types.go, worker.go:
    - Added op=stats&options=json response to support spiders.
      LP: #1105592
  * mgo/worker.go, pgp.go, worker.go:
    - Split UID keywords into letter/digit tokens for search.
      LP: #1108416
    - Using $all on search terms in mongo query.
  * scripts/fix-keywords.js:
    - Add script to repair uid keywords in existing Hockeypuck.
  * pgp_types.go, responses.go:
    - Display uat:::: placeholder in machine readable output.
      LP: #1104703
    - Removed debug print statement.
    - Uppercased fingerprint in machine readable output.
  * cmd/hockeypuck-mgo/main.go, mgo/client.go, mgo/keystats.go,
    mgo/pks.go, mgo/worker.go, pgp.go, pgp_types.go, responses.go,
    strings.go:
    - Several MongoDB improvements:
      - Leverage reversed fingerprint for long, short keyid lookup
        with regex indexed query, removed indexed on these.
        LP: #1128565
      - Replace map-reduce generated stats with time-bucket
        increments on load. LP: #1128611
    - Remove invalid UTF-8 characters from uid strings.
    - Reversed issuer key ID in signature for faster lookups
      (anchored regex for mongo, prefixed LIKE for RDBMS).
  * instroot/var/lib/hockeypuck/www/templates/pks/index.tmpl,
    mgo/keystats.go, mgo/worker.go, pgp.go, pgp_types.go, responses.go:
    - Require valid UID self-sign to load key material. LP: #1128561
    - Send proper key var to stats channel on insert/update.
    - Get UID of signature keyid in LookupKey(s), display in vindex.
      LP: #1120869
    - Aggregate loading statistics, bulk upsert increments to
      reduce mongodb load. LP: #1128611
  * mgo/worker.go, pgp.go, pgp_test.go, pgp_types.go, responses.go,
    strings.go:
    - Link all supported hash algorithms into runtime.
    - Recover from panic due to missing hash algorithm in
      key material verification, return as error.
    - Verify subkey signatures. LP: #1128561
    - Add unit test to catch invalid UID with missing self-sig
      LP: #1128561
    - Remove unused goroutine from checkValidSignatures.
  * mgo/worker.go, pgp.go, pgp_test.go:
    - Verify user attribute packets too. Some unsigned images
      cannot be unseen. LP: #1128561
  * mgo/worker.go, strings.go, strings_test.go:
    - Simplify keyword search, balance between MongoDB performance
      and search term flexibility. LP: #1108416
  * instroot/usr/share/hockeypuck-mgo/scripts/fix-keywords.js:
    - Update fix keyword script to use above simplified approach.
  * mgo/worker.go:
    - Escape regular expression characters from search terms.
  * cmd/hockeypuck-load/main.go, cmd/hockeypuck-mgo/main.go, config.go,
    log.go, mgo/client.go, mgo/keystats.go, mgo/pks.go, mgo/worker.go,
    pks.go:
    - Using standard logger, reopen log on SIGHUP/SIGUSR1/SIGUSR2.
      LP: #1121700
  * merge.go, mgo/worker.go, pgp.go, pgp_types.go:
    - Fix goroutine leaks in traverse, reading keys.
  * debian/hockeypuck.logrotate:
    - Add logrotate configuration. LP: #1121700
  * debian/control:
    - Add dependencies recommended for a ready-to-run server.
  * mgo/worker.go:
    - Update with reversed fingerprint.
  * mgo/client.go, mgo/worker.go:
    - Fix typo in modified stats aggregation.
      Make stats timestamp index unique.
  * hkp_types.go, instroot/var/lib/hockeypuck/www/templates/header.tmpl,
    mgo/client.go, mgo/pks.go, mgo/worker.go, pks.go, responses.go,
    server.go, status_types.go, templates.go, worker.go,
    instroot/var/lib/hockeypuck/www/templates/pks/stats.tmpl:
    - Change op=status to op=stats. Make distinction between
      "status" and "stats" elsewhere in the codebase while we're at it.
  * responses.go, server.go:
    - Default op=stats HTTP port to 11371, improve Host: parsing.
    - Respond with JSON for mr option if op=stats.
  * debian/copyright:
    - Proper Debian license attribution of all Go library dependencies
      redistributed in source package.

 -- Casey Marshall <casey.marshall@gazzang.com>  Mon, 04 Mar 2013 12:32:38 -0600

hockeypuck (0.8.1.0147~raring) raring; urgency=low

  [ Casey Marshall ]
  * mgo/worker.go, mgo/worker_test.go, pgp.go, pgp_types.go,
    pq/worker.go, responses.go:
    - Updates wrt go.crypto branch packet.Read.
    - Fixed an issue where valid public keys preceding an
      invalid public key were not send to the channel.
      LP: #1090980
  * pgp.go, pgp_types.go:
    - Updated unknown/unsupported packet parsing wrt
      changes in go.crypto merge.

 -- Casey Marshall <casey.marshall@gazzang.com>  Tue, 22 Jan 2013 21:10:03 -0600

hockeypuck (0.8.0147~raring) raring; urgency=low

  [ Casey Marshall ]
  * Opening 0.8 milestone.
  * cmd/lspgp/main.go, cmd/pktdump/main.go, mgo/worker.go,
    mgo/worker_test.go, pgp.go, pgp_types.go, pq/worker.go,
    responses.go:
    - Switch go.crypto from my fork to proper trunk source.
  * instroot/var/lib/hockeypuck/www/fonts/Droid_Sans =>
    instroot-extra/var/lib/hockeypuck/www/fonts/Droid_Sans
    scripts/crossbuild.sh:
    - Move droid sans font out of debian instroot, used only
      in cross-compile tar build.

  [ Dustin Kirkland ]
  * debian/manpages, debian/install, debian/rules,
    instroot/etc/init/hockeypuck-mgo.conf => debian/upstart,
    removed directory instroot/etc/init:
    - A handful of packaging recommendations

 -- Casey Marshall <casey.marshall@gazzang.com>  Tue, 22 Jan 2013 11:00:00 -0600

hockeypuck (0.7.0147~raring) raring; urgency=low

  [ Casey Marshall ]
  * Opening 0.7 milestone.
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, mgo/pks.go, mgo/worker.go,
    pks.go, worker.go:
    - Add support for PKS forwarding. LP: #1075379


=== gopath/src/launchpad.net/hockeypuck/debian/changelog ===
hockeypuck (1.0~a1) precise; urgency=low

  [ Casey Marshall ]
  * Opening 1.0~a1 development

 -- Casey Marshall <casey.marshall@gazzang.com>  Sat, 02 Mar 2013 14:00:44 -0600

hockeypuck (0.9) precise; urgency=low

  [ Casey Marshall ]
  * hkp_types.go, mgo/worker.go, responses.go, server.go,
    status_types.go, worker.go:
    - Added op=stats&options=json response to support spiders.
      LP: #1105592
  * mgo/worker.go, pgp.go, worker.go:
    - Split UID keywords into letter/digit tokens for search.
      LP: #1108416
    - Using $all on search terms in mongo query.
  * scripts/fix-keywords.js:
    - Add script to repair uid keywords in existing Hockeypuck.
  * pgp_types.go, responses.go:
    - Display uat:::: placeholder in machine readable output.
      LP: #1104703
    - Removed debug print statement.
    - Uppercased fingerprint in machine readable output.
  * cmd/hockeypuck-mgo/main.go, mgo/client.go, mgo/keystats.go,
    mgo/pks.go, mgo/worker.go, pgp.go, pgp_types.go, responses.go,
    strings.go:
    - Several MongoDB improvements:
      - Leverage reversed fingerprint for long, short keyid lookup
        with regex indexed query, removed indexed on these.
        LP: #1128565
      - Replace map-reduce generated stats with time-bucket
        increments on load. LP: #1128611
    - Remove invalid UTF-8 characters from uid strings.
    - Reversed issuer key ID in signature for faster lookups
      (anchored regex for mongo, prefixed LIKE for RDBMS).
  * instroot/var/lib/hockeypuck/www/templates/pks/index.tmpl,
    mgo/keystats.go, mgo/worker.go, pgp.go, pgp_types.go, responses.go:
    - Require valid UID self-sign to load key material. LP: #1128561
    - Send proper key var to stats channel on insert/update.
    - Get UID of signature keyid in LookupKey(s), display in vindex.
      LP: #1120869
    - Aggregate loading statistics, bulk upsert increments to
      reduce mongodb load. LP: #1128611
  * mgo/worker.go, pgp.go, pgp_test.go, pgp_types.go, responses.go,
    strings.go:
    - Link all supported hash algorithms into runtime.
    - Recover from panic due to missing hash algorithm in
      key material verification, return as error.
    - Verify subkey signatures. LP: #1128561
    - Add unit test to catch invalid UID with missing self-sig
      LP: #1128561
    - Remove unused goroutine from checkValidSignatures.
  * mgo/worker.go, pgp.go, pgp_test.go:
    - Verify user attribute packets too. Some unsigned images
      cannot be unseen. LP: #1128561
  * mgo/worker.go, strings.go, strings_test.go:
    - Simplify keyword search, balance between MongoDB performance
      and search term flexibility. LP: #1108416
  * instroot/usr/share/hockeypuck-mgo/scripts/fix-keywords.js:
    - Update fix keyword script to use above simplified approach.
  * mgo/worker.go:
    - Escape regular expression characters from search terms.
  * cmd/hockeypuck-load/main.go, cmd/hockeypuck-mgo/main.go, config.go,
    log.go, mgo/client.go, mgo/keystats.go, mgo/pks.go, mgo/worker.go,
    pks.go:
    - Using standard logger, reopen log on SIGHUP/SIGUSR1/SIGUSR2.
      LP: #1121700
  * merge.go, mgo/worker.go, pgp.go, pgp_types.go:
    - Fix goroutine leaks in traverse, reading keys.
  * debian/hockeypuck.logrotate:
    - Add logrotate configuration. LP: #1121700
  * debian/control:
    - Add dependencies recommended for a ready-to-run server.
  * mgo/worker.go:
    - Update with reversed fingerprint.
  * mgo/client.go, mgo/worker.go:
    - Fix typo in modified stats aggregation. Make stats timestamp index unique.
  * hkp_types.go, instroot/var/lib/hockeypuck/www/templates/header.tmpl,
    mgo/client.go, mgo/pks.go, mgo/worker.go, pks.go, responses.go,
    server.go, status_types.go, templates.go, worker.go,
    instroot/var/lib/hockeypuck/www/templates/pks/status.tmpl =>
    instroot/var/lib/hockeypuck/www/templates/pks/stats.tmpl:
    - Change op=status to op=stats. Make distinction between "status" and "stats"
      elsewhere in the codebase while we're at it.
  * responses.go, server.go:
    - Default op=stats HTTP port to 11371, improve Host: parsing.
    - Respond with JSON for mr option if op=stats.

 -- Casey Marshall <casey.marshall@gazzang.com>  Wed, 27 Feb 2013 18:10:28 -0600

## hockeypuck 0.9.0149~raring-0ubuntu1

=== debian/changelog ===
hockeypuck (0.9.0149~raring-0ubuntu1) raring; urgency=low

  * New upstream, security/bugfix release

 -- Dustin Kirkland <kirkland@ubuntu.com>  Thu, 14 Mar 2013 16:15:31 -0500

hockeypuck (0.9.0149~raring) raring; urgency=low

  [ Casey Marshall ]
  * hkp_types.go, mgo/worker.go, responses.go, server.go,
    status_types.go, worker.go:
    - Added op=stats&options=json response to support spiders.
      LP: #1105592
  * mgo/worker.go, pgp.go, worker.go:
    - Split UID keywords into letter/digit tokens for search.
      LP: #1108416
    - Using $all on search terms in mongo query.
  * scripts/fix-keywords.js:
    - Add script to repair uid keywords in existing Hockeypuck.
  * pgp_types.go, responses.go:
    - Display uat:::: placeholder in machine readable output.
      LP: #1104703
    - Removed debug print statement.
    - Uppercased fingerprint in machine readable output.
  * cmd/hockeypuck-mgo/main.go, mgo/client.go, mgo/keystats.go,
    mgo/pks.go, mgo/worker.go, pgp.go, pgp_types.go, responses.go,
    strings.go:
    - Several MongoDB improvements:
      - Leverage reversed fingerprint for long, short keyid lookup
        with regex indexed query, removed indexed on these.
        LP: #1128565
      - Replace map-reduce generated stats with time-bucket
        increments on load. LP: #1128611
    - Remove invalid UTF-8 characters from uid strings.
    - Reversed issuer key ID in signature for faster lookups
      (anchored regex for mongo, prefixed LIKE for RDBMS).
  * instroot/var/lib/hockeypuck/www/templates/pks/index.tmpl,
    mgo/keystats.go, mgo/worker.go, pgp.go, pgp_types.go, responses.go:
    - Require valid UID self-sign to load key material. LP: #1128561
    - Send proper key var to stats channel on insert/update.
    - Get UID of signature keyid in LookupKey(s), display in vindex.
      LP: #1120869
    - Aggregate loading statistics, bulk upsert increments to
      reduce mongodb load. LP: #1128611
  * mgo/worker.go, pgp.go, pgp_test.go, pgp_types.go, responses.go,
    strings.go:
    - Link all supported hash algorithms into runtime.
    - Recover from panic due to missing hash algorithm in
      key material verification, return as error.
    - Verify subkey signatures. LP: #1128561
    - Add unit test to catch invalid UID with missing self-sig
      LP: #1128561
    - Remove unused goroutine from checkValidSignatures.
  * mgo/worker.go, pgp.go, pgp_test.go:
    - Verify user attribute packets too. Some unsigned images
      cannot be unseen. LP: #1128561
  * mgo/worker.go, strings.go, strings_test.go:
    - Simplify keyword search, balance between MongoDB performance
      and search term flexibility. LP: #1108416
  * instroot/usr/share/hockeypuck-mgo/scripts/fix-keywords.js:
    - Update fix keyword script to use above simplified approach.
  * mgo/worker.go:
    - Escape regular expression characters from search terms.
  * cmd/hockeypuck-load/main.go, cmd/hockeypuck-mgo/main.go, config.go,
    log.go, mgo/client.go, mgo/keystats.go, mgo/pks.go, mgo/worker.go,
    pks.go:
    - Using standard logger, reopen log on SIGHUP/SIGUSR1/SIGUSR2.
      LP: #1121700
  * merge.go, mgo/worker.go, pgp.go, pgp_types.go:
    - Fix goroutine leaks in traverse, reading keys.
  * debian/hockeypuck.logrotate:
    - Add logrotate configuration. LP: #1121700
  * debian/control:
    - Add dependencies recommended for a ready-to-run server.
  * mgo/worker.go:
    - Update with reversed fingerprint.
  * mgo/client.go, mgo/worker.go:
    - Fix typo in modified stats aggregation.
      Make stats timestamp index unique.
  * hkp_types.go, instroot/var/lib/hockeypuck/www/templates/header.tmpl,
    mgo/client.go, mgo/pks.go, mgo/worker.go, pks.go, responses.go,
    server.go, status_types.go, templates.go, worker.go,
    instroot/var/lib/hockeypuck/www/templates/pks/stats.tmpl:
    - Change op=status to op=stats. Make distinction between
      "status" and "stats" elsewhere in the codebase while we're at it.
  * responses.go, server.go:
    - Default op=stats HTTP port to 11371, improve Host: parsing.
    - Respond with JSON for mr option if op=stats.
  * debian/copyright:
    - Proper Debian license attribution of all Go library dependencies
      redistributed in source package.
  * pgp.go:
    - Fixed deadlock in ReadValidKeys, defer draining source channels
      in its goroutine.

 -- Casey Marshall <casey.marshall@gazzang.com>  Sat, 09 Mar 2013 23:55:24 -0600

hockeypuck (0.8.1.0149~raring) raring; urgency=low

  [ Casey Marshall ]
  * mgo/worker.go, mgo/worker_test.go, pgp.go, pgp_types.go,
    pq/worker.go, responses.go:
    - Updates wrt go.crypto branch packet.Read.
    - Fixed an issue where valid public keys preceding an
      invalid public key were not send to the channel.
      LP: #1090980
  * pgp.go, pgp_types.go:
    - Updated unknown/unsupported packet parsing wrt
      changes in go.crypto merge.

 -- Casey Marshall <casey.marshall@gazzang.com>  Tue, 22 Jan 2013 21:10:03 -0600

hockeypuck (0.8.0149~raring) raring; urgency=low

  [ Casey Marshall ]
  * Opening 0.8 milestone.
  * cmd/lspgp/main.go, cmd/pktdump/main.go, mgo/worker.go,
    mgo/worker_test.go, pgp.go, pgp_types.go, pq/worker.go,
    responses.go:
    - Switch go.crypto from my fork to proper trunk source.
  * instroot/var/lib/hockeypuck/www/fonts/Droid_Sans =>
    instroot-extra/var/lib/hockeypuck/www/fonts/Droid_Sans
    scripts/crossbuild.sh:
    - Move droid sans font out of debian instroot, used only
      in cross-compile tar build.

  [ Dustin Kirkland ]
  * debian/manpages, debian/install, debian/rules,
    instroot/etc/init/hockeypuck-mgo.conf => debian/upstart,
    removed directory instroot/etc/init:
    - A handful of packaging recommendations

 -- Casey Marshall <casey.marshall@gazzang.com>  Tue, 22 Jan 2013 11:00:00 -0600

hockeypuck (0.7.0149~raring) raring; urgency=low

  [ Casey Marshall ]
  * Opening 0.7 milestone.
  * cli/cli.go, cmd/hockeypuck-mgo/main.go, mgo/pks.go, mgo/worker.go,


=== debian/control ===
Source: hockeypuck
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Casey Marshall <casey.marshall@gazzang.com>
Build-Depends: debhelper (>= 8.0.0), golang-go
Standards-Version: 3.9.3
Homepage: http://launchpad.net/hockeypuck

Package: hockeypuck
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, fonts-droid
Recommends:
 logrotate, mongodb-10gen | mongodb-server, upstart
Description: OpenPGP Key Server
 Hockeypuck is an OpenPGP Key Server implementing the HTTP Keyserver Protocol.

=== gopath/src/launchpad.net/hockeypuck/debian/control ===
--- 
+++ 
@@ -10,6 +10,6 @@
 Architecture: i386 amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, fonts-droid
 Recommends:
- mongodb-server
+ logrotate, mongodb-10gen | mongodb-server, upstart
 Description: OpenPGP Key Server
  Hockeypuck is an OpenPGP Key Server implementing the HTTP Keyserver Protocol.

## hockeypuck 1.0~rel20140413+7a1892a~trusty

=== doc/Makefile ===

all:
	./build.sh

fakebuild:
	./fakebuild.sh

deploy: all output/index.html
	./deploy.sh

output/index.html: all

clean:
	$(RM) -r output

.PHONY: all deploy clean

=== charms/precise/hockeypuck/hooks/Makefile ===

all: peer-relations gossip-relations cluster-relations

peer-relations: peer-relation-joined peer-relation-broken peer-relation-changed peer-relation-departed

gossip-relations: gossip-relation-joined gossip-relation-broken gossip-relation-changed gossip-relation-departed

cluster-relations: cluster-relation-joined cluster-relation-broken cluster-relation-changed cluster-relation-departed

peer-relation-%: recon-relation-changed
	ln -s recon-relation-changed $@

gossip-relation-%: recon-relation-changed
	ln -s recon-relation-changed $@

cluster-relation-%: recon-relation-changed
	ln -s recon-relation-changed $@

clean:
	$(RM) peer-* gossip-* cluster-*

.PHONY: all peer-relations gossip-relations cluster-relations

=== debian/changelog ===
hockeypuck (1.0~rel20140413+7a1892a~trusty) trusty; urgency=medium

  * Hockeypuck 1.0 release

 -- Casey Marshall <cmars@cmarstech.com>  Sun, 13 Apr 2014 20:06:01 -0500

hockeypuck (1.0~rc2~rel20140413+7a1892a~trusty) trusty; urgency=medium

  * Opening 1.0~rc2

 -- Casey Marshall <cmars@cmarstech.com>  Tue, 01 Apr 2014 00:54:51 -0500

hockeypuck (1.0~rc1~rel20140413+7a1892a~trusty) trusty; urgency=low

  [ Casey Marshall ]
  * Opening 1.0~rc1 development.
  * doc/conf.py, doc/stories/community.txt, doc/stories/doc.txt,
    doc/stories/install-tarball.txt, doc/stories/install-ubuntu.txt,
    scripts/crossbuild:
    - Documentation improvements.
    - Fix crossbuild script.
  * doc/stories/doc.txt, doc/stories/pre-populating.txt:
    - Add page on pre-populating Hockeypuck.
  * openpgp/responses.go, openpgp/schema.go, openpgp/sort.go:
    - Use ShortId() instead of fingerprint slice, as v3 keys do not have
      the same length fingerprint.
    - Add indexes on pubkey_uuid for subkey, uid and uat tables.
    - Check for nil selfSignature when sorting uids.
  * openpgp/io.go, openpgp/types.go:
    - Fix state flag values, remove unnecessary validation method.
  * openpgp/worker.go:
    - Support subkey fingerprint search w/PostgreSQL backend.
      LP: #1234774
  * hkp/requests.go, openpgp/add.go, openpgp/index.go,
    openpgp/pubkey.go, openpgp/resolve_test.go, openpgp/responses.go,
    openpgp/signature.go, openpgp/sort.go, openpgp/subkey.go,
    openpgp/userattribute.go, openpgp/userid.go, openpgp/worker.go:
    - SKS-like index & vindex search results page. LP: #1234771
    - Set signature expiration when linking self sigs.
    - Update signature expiration on merge.
  * === added directory doc/files, doc/conf.py, doc/files/gohkp.png,
    renamed directory doc/stories => doc/pages:
    - Revised & restructured documentation.
  * doc/Makefile, doc/deploy.sh, doc/pages/index.txt, doc/pages/install-
    source.txt, doc/pages/install-ubuntu.txt, doc/pages/pre-
    populating.txt:
    - Revised documentation, add http://hockeypuck.github.io doc deploy
      script.
  * cmd/hockeypuck/run.go, hkp/templates.go,
    openpgp/index.go, === removed directory
    instroot/var/lib/hockeypuck/www/templates, router.go:
    - Moved templates into string constants. Make webroot optional for
      CSS and fonts, but not essential to running the service.
  * instroot/usr/share/man/man1/hockeypuck.1:
    - Update man page to match new subcommand CLI.
  * cmd/hockeypuck/delete.go, cmd/hockeypuck/load.go,
    cmd/hockeypuck/main.go, dependencies.tsv, Makefile, openpgp/add.go,
    openpgp/db.go, openpgp/io_test.go, openpgp/loader.go,
    openpgp/merge.go, openpgp/merge_test.go:
    - Fixed a defect in MergeKey where signatures were not merged.
    - Added 'hockeypuck delete' subcommand.
    - Using godeps to freeze dependencies.
    - Insert if not exists for non-bulk loading key inserts.
  * === added directory charms:
    - Add juju charms for hockeypuck & sks. LP: #1233812
  * - Denormalized signatures in schema.
    - Improve delete command to lookup by fingerprint.
    - Introduced errgo for improved error tracing.
    - Parameterized upload dump file load playbooks in int-tests.
    - More openpgp round-trip db test cases.

 -- Casey Marshall <cmars@cmarstech.com>  Fri, 04 Oct 2013 15:15:24 -0500

hockeypuck (1.0~b2~bzr267~precise~rel20140413+7a1892a~trusty) trusty; urgency=low

  [ Casey Marshall ]
  * Opening 1.0~b1 development and a bottle of
    Maker's. SKS reconciliation now working in
    the small. Cheers!
  * cmd/sks-hash/main.go, instroot/etc/hockeypuck/hockeypuck.conf,
    openpgp/recon.go, openpgp/responses.go, openpgp/validate.go,
    openpgp/worker.go:
    - Add commented-out SKS recon configuration stanza.
    - Check errors in prefix tree insert/remove.
    - Fixed Worker.LookupKey to correctly return error.
    - go fmt
  * cmd/hockeypuck-load/main.go:
    - Add -drop and -take command line arguments to help
      create synchronization test cases.
  * **/*.go, openpgp/doc.go:
    - Add/fix package godoc comments. LP: #1117274
    - Update debug utility commands wrt openpgp changes.
  * === removed directory cmd/lspgp, === removed directory cmd/pqtest:
    - Removed unused 'spike' debug utilities, no longer useful. 
  * openpgp/recon.go:
    - Fix deadlock when adding keys from SKS recon.
  * debian/mkdists:
    - Packaging script should fail on error.
  * openpgp/recon.go:
    - Add previously missing elements to prefix tree.
  * hkp/requests.go, openpgp/add.go, openpgp/io.go, openpgp/recon.go,
    openpgp/responses.go, openpgp/schema.go, openpgp/types.go,
    openpgp/worker.go:
    - Add fallback to track unsupported keys discovered through
      gossip. LP: #1208290
    - Initialize current digests in KeyChange for defined behavior in
      change consumers.
  * cmd/hockeypuck-load/main.go, openpgp/recon.go:
    - Log public key digest when loading.
    - Removed key reversal to match latest conflux Zp byte ordering fix.
  * cmd/hockeypuck-load/main.go, hkp/requests.go, openpgp/add.go,
    openpgp/recon.go, openpgp/worker.go:
    - Fix off-by-one in drop, take flags of hockeypuck-load. Fix i386
      compile issue with max int.
    - Workaround some concurrency issues between adding keys, recon recovery,
      and incoming queries.
  * openpgp/add.go, openpgp/recon.go, openpgp/worker.go:
    - Fix goroutine leak from early exit while enumerating keys.
    - Multiplex peer recovery to goroutines aggregating recovery requests,
      one per peer.
    - Refactored HKP host:port derivation from recon.Recover into conflux.
    - go fmt.
  * openpgp/validate.go:
    - Add hockeypuck.openpgp.strict option to reject key material containing
      *anything* we can't parse. Useful for peering with SKS, as we can
      track recovered unsupported keys for future reloading. LP: #1208290
  * cmd/hockeypuck/main.go, cmd/sks-hash/main.go, hkp/requests.go,


=== debian/rules ===
#!/usr/bin/make -f

%:
	GOPATH=$(shell pwd)/build dh $@

## hockeypuck 1.0~rel20140413+7a1892a~trusty.1

=== Makefile ===

PACKAGE=github.com/hockeypuck/hockeypuck
GODEPS=launchpad.net/godeps
VERSION=$(shell head -1 debian/changelog | sed 's/.*(//;s/).*//;')

all: compile

compile:
	GOPATH=$(shell pwd)/build go install -ldflags "-X ${PACKAGE}.Version ${VERSION}" ${PACKAGE}/cmd/hockeypuck
	make -C doc fakebuild

build:
	GOPATH=$(shell pwd)/build go get ${PACKAGE}/...
	GOPATH=$(shell pwd)/build make godeps compile

godeps: require-godeps apply-godeps

fmt:
	gofmt -w=true ./...

debs: debbin debsrc

debsrc: debbin clean
	debuild -S -k0x879CF8AA8DDA301A

debbin: freeze-build
	debuild -us -uc -i -b

freeze-build:
	GOPATH=$(shell pwd)/build go get ${PACKAGE}/...
	GOPATH=$(shell pwd)/build make apply-godeps

freeze-godeps: require-godeps
	${GOPATH}/bin/godeps $(go list ${PACKAGE}/...) > dependencies.tsv

apply-godeps: require-godeps
	${GOPATH}/bin/godeps -u dependencies.tsv

require-godeps:
	go get -u ${GODEPS}
	go install ${GODEPS}

clean:
	rm -rf build/bin build/pkg
	make -C doc clean

src-clean:
	rm -rf build

pkg-clean:
	rm -f ../hockeypuck_*.deb ../hockeypuck_*.dsc ../hockeypuck_*.changes ../hockeypuck_*.build ../hockeypuck_*.tar.gz 

all-clean: clean src-clean pkg-clean

.PHONY: all compile godeps fmt debs debsrc debbin freeze-build freeze-godeps apply-godeps require-godeps clean src-clean pkg-clean build all-clean

=== charms/trusty/hockeypuck/Makefile ===

MAKEDIR := $(shell pwd)

release:
	rm hooks/install
	sed 's/%%REPO%%/ppa/' hooks/install.pkg > hooks/install
	chmod +x hooks/install

unstable:
	rm hooks/install
	sed 's/%%REPO%%/unstable/' hooks/install.pkg > hooks/install
	chmod +x hooks/install

dev: files/hockeypuck files/instroot.tar.gz files/debian.tar.gz
	rm hooks/install
	cp hooks/install.dev hooks/install
	chmod +x hooks/install

files/hockeypuck:
	go build -o $@ github.com/hockeypuck/hockeypuck/cmd/hockeypuck

files/instroot.tar.gz:
	cd ../../../instroot; tar cvf $(MAKEDIR)/files/instroot.tar .
	cd ../../../instroot-extra; tar rvf $(MAKEDIR)/files/instroot.tar .
	gzip -9 files/instroot.tar

files/debian.tar.gz:
	cd ../../../debian; tar cvf $(MAKEDIR)/files/debian.tar .
	gzip -9 files/debian.tar

clean:
	$(RM) files/hockeypuck files/instroot.tar.gz files/debian.tar.gz

.PHONY: all clean

=== debian/changelog ===
hockeypuck (1.0~rel20140413+7a1892a~trusty.1) utopic; urgency=medium

  * Drop unnecessary upstart recommends, the package has an init.d script as
    well which is supported by all init systems. (LP: #1351306)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 03 Sep 2014 09:44:14 +0200

=== build/src/github.com/hockeypuck/hockeypuck/debian/control ===
Source: hockeypuck
Section: net
Priority: optional
Maintainer: Casey Marshall <cmars@cmarstech.com>
Build-Depends: debhelper (>= 8.0.0), golang-go (>= 2:1.1)
Standards-Version: 3.9.5
Homepage: https://hockeypuck.github.io/

Package: hockeypuck
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends:
 logrotate, upstart, fonts-droid
Suggests:
 postgresql
Description: OpenPGP Key Server
 Hockeypuck is an OpenPGP Key Server implementing the HTTP Keyserver Protocol.

=== debian/control ===
Source: hockeypuck
Section: net
Priority: optional
Maintainer: Casey Marshall <cmars@cmarstech.com>
Build-Depends: debhelper (>= 8.0.0), golang-go (>= 2:1.1)
Standards-Version: 3.9.5
Homepage: https://hockeypuck.github.io/

Package: hockeypuck
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends:
 logrotate, fonts-droid
Suggests:
 postgresql
Description: OpenPGP Key Server
 Hockeypuck is an OpenPGP Key Server implementing the HTTP Keyserver Protocol.

## hockeypuck 1.0~rel20140413+7a1892a~trusty.2

=== Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 all: compile
 
 compile:
-	GOPATH=$(shell pwd)/build go install -ldflags "-X ${PACKAGE}.Version ${VERSION}" ${PACKAGE}/cmd/hockeypuck
+	GOPATH=$(shell pwd)/build go install -ldflags "-X ${PACKAGE}.Version=${VERSION}" ${PACKAGE}/cmd/hockeypuck
 	make -C doc fakebuild
 
 build:

=== debian/changelog ===
hockeypuck (1.0~rel20140413+7a1892a~trusty.2) focal; urgency=medium

  * Fix FTBFS:
    - debian/rules: Export a home directory to fix build cache initialization.
    - Makefile: Fix usage of -X flag for Go 1.5+.

 -- Logan Rosen <logan@ubuntu.com>  Tue, 25 Feb 2020 21:42:13 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: hockeypuck
 Section: net
 Priority: optional
-Maintainer: Casey Marshall <cmars@cmarstech.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Casey Marshall <cmars@cmarstech.com>
 Build-Depends: debhelper (>= 8.0.0), golang-go (>= 2:1.1)
 Standards-Version: 3.9.5
 Homepage: https://hockeypuck.github.io/

=== debian/rules ===
#!/usr/bin/make -f

export HOME = $(CURDIR)

%:
	GOPATH=$(shell pwd)/build dh $@
